#include "main.h"
#include "FindFile.h"
#include "log_file.h"
#include "imagepak.h"
#include "coders.h"
#include "aztec_1.h"

char buffer[4000];

int ARecog(char*in);

int main()
{
	//Test

	LOG_FILE log;

	log.BLog("out1.log");

	FindFile ff("D:\\Aztec\\Test\\1v\\img\\");

	int i,j,all=0;
	char file[256];
	char buf[256];
	
	
	//cycle for recognize all test DataMatrix files
	printf("Start!\n");
	for(i=0;i<ff.AllFoundFiles;i++)
	{	
		sprintf(buf,"-----------------Picture #%d:",i);strcat(buf,ff.Files[i]);
		printf(buf);printf("\n");
		log.Log(buf);
		//Open file, make matrix and decode
		lstrcpy(file,"D:\\Aztec\\Test\\1v\\img\\");lstrcat(file,ff.Files[i]);		
		j=ARecog(file);
		sprintf(buf,"%d",j);
		log.Log(buf);
		if (j==0) log.Log(buffer);
		if (j==0) all++;
		log.Log("-----------------end recog pic");
	}

	log.Log("\n-----------------All end recog pic");
	sprintf(buf,"%d/%d - D:=%6.4f",all,i,(double)all/i);
	log.Log(buf);
	

	return 0;
}

int ARecog(char*in)
{	

	IMG image_code=OpenGraphFile(in);
	image_code.on=1;

    // Convert 24 bits image to 8
    IMG Img8=Img24To8(image_code);

	RECT r;
	r.left=0;
	r.right=Img8.Width;
	r.top=0;
	r.bottom=Img8.Height;
        int param=120;
		int pixels=400;

	if (pixels<r.right) Adaptive2ThresholdImage(Img8,param,50,r,pixels);
	else ThresholdImage(Img8,param,r);

	r.right-=1;
	r.bottom-=1;

	int p[20];
    char outdata[4000];
	

	int j=Recognize(Img8,r,p,outdata);

	lstrcpy(buffer,outdata);

	DeleteByte(Img8.bytes);
	DeleteByte(image_code.bytes);

	return j;
	
}